/* filename:    paraconv1.g
** description: compare posterior means from importance sampler and MH
**              
*/

new;
closeall;
library user, pgraph;
cls;
outwidth 128;

#include nkmp_mod.src;
#include nkmp_para.src;
#include nkmp_spec.g;
#include pathspec.g;

para  = pmsv(msel);
npara = rows(para);
{para,para_names} = psel(para,msel);

ndraws_grid = 10 | seqa(100000,100000,9);
ndraws_n    = rows(ndraws_grid);

/******************************************************************
**         Compute Means based on MH output
******************************************************************/

mhrun       = "32";
nburn       = 1;        /* Number of initial draws to be discarded */

lpath  = parapath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\pa"  ;

para_mh_mean   = zeros(ndraws_n,npara);
ndraws_gridadj = ndraws_grid - nburn+1;

open fhdraw = ^ldraw for read;

drawrow   = seekr( fhdraw, nburn);
drawblock = readr( fhdraw, ndraws_gridadj[1]);

drawsum = sumc(drawblock)';
para_mh_mean[1,.] = drawsum/ndraws_gridadj[1];

i = 2;
do until i > ndraws_n;

   nread = ndraws_gridadj[i]-ndraws_gridadj[i-1];
   drawblock = readr( fhdraw, nread);
   drawsum = drawsum+sumc(drawblock)';
   para_mh_mean[i,.] = drawsum/ndraws_gridadj[i];
   i = i+1;   

endo;

closeall fhdraw;

para_mh_mean1 = para_mh_mean;

/******************************************************************
**         Compute Means based on MH output
******************************************************************/

mhrun       = "42";
nburn       = 1;        /* Number of initial draws to be discarded */

lpath  = parapath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\pa"  ;

para_mh_mean   = zeros(ndraws_n,npara);
ndraws_gridadj = ndraws_grid - nburn+1;

open fhdraw = ^ldraw for read;

drawrow   = seekr( fhdraw, nburn);
drawblock = readr( fhdraw, ndraws_gridadj[1]);

drawsum = sumc(drawblock)';
para_mh_mean[1,.] = drawsum/ndraws_gridadj[1];

i = 2;
do until i > ndraws_n;

   nread = ndraws_gridadj[i]-ndraws_gridadj[i-1];
   drawblock = readr( fhdraw, nread);
   drawsum = drawsum+sumc(drawblock)';
   para_mh_mean[i,.] = drawsum/ndraws_gridadj[i];
   i = i+1;   

endo;

closeall fhdraw;

para_mh_mean2 = para_mh_mean;

/******************************************************************
**         Compute Means based on MH output
******************************************************************/

mhrun       = "52";
nburn       = 1;        /* Number of initial draws to be discarded */

lpath  = parapath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\pa"  ;

para_mh_mean   = zeros(ndraws_n,npara);
ndraws_gridadj = ndraws_grid - nburn+1;

open fhdraw = ^ldraw for read;

drawrow   = seekr( fhdraw, nburn);
drawblock = readr( fhdraw, ndraws_gridadj[1]);

drawsum = sumc(drawblock)';
para_mh_mean[1,.] = drawsum/ndraws_gridadj[1];

i = 2;
do until i > ndraws_n;

   nread = ndraws_gridadj[i]-ndraws_gridadj[i-1];
   drawblock = readr( fhdraw, nread);
   drawsum = drawsum+sumc(drawblock)';
   para_mh_mean[i,.] = drawsum/ndraws_gridadj[i];
   i = i+1;   

endo;

closeall fhdraw;

para_mh_mean3 = para_mh_mean;

/******************************************************************
**         Compute Means based on MH output
******************************************************************/

mhrun       = "62";
nburn       = 1;        /* Number of initial draws to be discarded */

lpath  = parapath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\pa"  ;

para_mh_mean   = zeros(ndraws_n,npara);
ndraws_gridadj = ndraws_grid - nburn+1;

open fhdraw = ^ldraw for read;

drawrow   = seekr( fhdraw, nburn);
drawblock = readr( fhdraw, ndraws_gridadj[1]);

drawsum = sumc(drawblock)';
para_mh_mean[1,.] = drawsum/ndraws_gridadj[1];

i = 2;
do until i > ndraws_n;

   nread = ndraws_gridadj[i]-ndraws_gridadj[i-1];
   drawblock = readr( fhdraw, nread);
   drawsum = drawsum+sumc(drawblock)';
   para_mh_mean[i,.] = drawsum/ndraws_gridadj[i];
   i = i+1;   

endo;

closeall fhdraw;

para_mh_mean4 = para_mh_mean;


goto eofisread;

/******************************************************************
**         Compute Means based on IS output
******************************************************************/

isrun = "1";

/** input files **/
lpath = parapath $+ "\\isrun" $+ isrun;
iter  = 1;
lstat = lpath $+ "\\st" $+ ftos(iter,"%0*.*lf",2,0);
lpara = lpath $+ "\\pa" $+ ftos(iter,"%0*.*lf",2,0);

para_is_mean   = zeros(ndraws_n,npara);

open fhpara = ^lpara for read;
open fhstat = ^lstat for read;

j = 1;
do until j > npara;

   drawrow = seekr( fhstat,1);
   drawrow = seekr( fhpara,1);

   drawblock = readr( fhstat, ndraws_grid[1]);
   drawwgtcol = drawblock[.,4];
   nwgt = exp(drawwgtcol)/sumc(exp(drawwgtcol));

   drawblock = readr( fhpara, ndraws_grid[1]);
   drawparacol = drawblock[.,j];

   para_is_mean[1,j] = sumc( drawparacol.*nwgt )';

   i = 2;
   do until i > ndraws_n;

      drawblock = readr( fhstat, ndraws_grid[i]-ndraws_grid[i-1]);
      drawwgtcol = drawwgtcol | drawblock[.,4];
      nwgt = exp(drawwgtcol)/sumc(exp(drawwgtcol));

      drawblock = readr( fhpara, ndraws_grid[1]);
      drawparacol = drawparacol | drawblock[.,j];

      para_is_mean[i,j] = sumc( drawparacol.*nwgt )';

      i = i+1;
   endo;

   j = j+1;

endo;

closeall fhstat, fhpara;

para_is_mean1 = para_is_mean;

/******************************************************************
**         Compute Means based on IS output
******************************************************************/

isrun = "1";

/** input files **/
lpath = parapath $+ "\\isrun" $+ isrun;
iter  = 1;
lstat = lpath $+ "\\st" $+ ftos(iter,"%0*.*lf",2,0);
lpara = lpath $+ "\\pa" $+ ftos(iter,"%0*.*lf",2,0);

para_is_mean   = zeros(ndraws_n,npara);

open fhpara = ^lpara for read;
open fhstat = ^lstat for read;

j = 1;
do until j > npara;

   drawrow = seekr( fhstat,1);
   drawrow = seekr( fhpara,1);

   drawblock = readr( fhstat, ndraws_grid[1]);
   drawwgtcol = drawblock[.,4];
   nwgt = exp(drawwgtcol)/sumc(exp(drawwgtcol));

   drawblock = readr( fhpara, ndraws_grid[1]);
   drawparacol = drawblock[.,j];

   para_is_mean[1,j] = sumc( drawparacol.*nwgt )';

   i = 2;
   do until i > ndraws_n;

      drawblock = readr( fhstat, ndraws_grid[i]-ndraws_grid[i-1]);
      drawwgtcol = drawwgtcol | drawblock[.,4];
      nwgt = exp(drawwgtcol)/sumc(exp(drawwgtcol));

      drawblock = readr( fhpara, ndraws_grid[1]);
      drawparacol = drawparacol | drawblock[.,j];

      para_is_mean[i,j] = sumc( drawparacol.*nwgt )';

      i = i+1;
   endo;

   j = j+1;

endo;


closeall fhstat, fhpara;

para_is_mean2 = para_is_mean;

eofisread:

/******************************************************************
**         Plot results
******************************************************************/


graphset;
fonts("microb");
_ptitlht = 0.4;
_paxht = 0.4;
_pnumht = 0.4;
_pltype = {6 1 2}; 
/* _plegstr = "Metropolis Alg 1\000Metropolis Alg 2\000Importance Sampl 1\000Importance Sampl 2"; 
_plegctl = {2 4 4 4}; */
_plwidth = 3.5;
_pcolor = { 4 1 };
_protate = 1;

begwind;
window(4,4,0);

j = 1;
do until j > npara;

   title(para_names[j]);
   /* xy(ndraws_grid,para_mh_mean1[.,j]~para_mh_mean2[.,j]~para_is_mean1[.,j]~para_is_mean2[.,j]); */
   xy(ndraws_grid,para_mh_mean1[.,j]~para_mh_mean2[.,j]~para_mh_mean3[.,j]~para_mh_mean4[.,j]); 
   nextwind;

   _plegctl = { };

   j = j+1;
   
endo;

endwind;

end;
