/* filename:    nkmp_gewchk3.g
** description: Compute differentials between average test statistics
**              
*/

new;
closeall;
library user, pgraph;
cls;
outwidth 128;

#include nkmp_mod.src;
#include nkmp_para.src;
#include nkmp_spec.g;

#include pathspec.g;

para  = pmsv(msel);
npara = rows(para);
{para,para_names} = psel(para,msel);

/*******************************************************
** Statistics from Prior Simulator
*******************************************************/

mhrun = "0";
nburn = 1;
block_size = 1000;

lpath  = parapath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\patstfcn"  ;

open fhdraw = ^ldraw for read;

drawrow = readr( fhdraw, nburn); 
drawdim = cols(drawrow);
drawrow = seekr( fhdraw, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);

eofloop = 0;
ndraws  = 0;

do until eofloop; 

   drawblock = readr( fhdraw, block_size );

   drawmean  = drawmean    + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';

   ndraws = ndraws + rows(drawblock);

   eofloop = eof(fhdraw);

endo;

drawmean0    = drawmean/ndraws;
drawsqmean0  = drawsqmean/ndraws;
drawvar0     = drawsqmean0 - (drawmean0)^2;
drawmeanvar0 = drawvar0/ndraws;

closeall fhdraws;


/*******************************************************
** Statistics from Posterior Simulator (I)
*******************************************************/

mhrun = "1";
nburn = 1;
block_size = 5000;

lpath  = parapath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\patstfcn"  ;

open fhdraw = ^ldraw for read;

drawrow = readr( fhdraw, nburn); 
drawdim = cols(drawrow);
drawrow = seekr( fhdraw, nburn);

drawmean   = zeros(1,drawdim);
drawsqmean = zeros(1,drawdim);

eofloop = 0;
ndraws  = 0;

do until eofloop; 

   drawblock = readr( fhdraw, block_size );

   drawmean  = drawmean    + sumc(drawblock)';
   drawsqmean = drawsqmean + sumc(drawblock^2)';

   ndraws = ndraws + rows(drawblock);

   eofloop = eof(fhdraw);

endo;

drawmean1    = drawmean/ndraws;
drawsqmean1  = drawsqmean/ndraws;
drawvar1     = drawsqmean1 - (drawmean1)^2;
drawmeanvar1 = drawvar1/ndraws;

closeall fhdraws;

drawmeanvar1;

/*******************************************************
** Statistics from Posterior Simulator (II)
*******************************************************/

mhrun = "1";
nburn = 1;
block_size = 1000;
hmax = 1500;

lpath  = parapath $+ "\\mhrun" $+ mhrun;
ldraw  = lpath $+ "\\patstfcn"  ;

open fhdraw = ^ldraw for read;

drawrow = readr( fhdraw, nburn); 
drawdim = cols(drawrow);

i = 1;
do until i > drawdim;

   "Processing Column" i;
   pause(1E-20);

   drawrow = seekr( fhdraw, nburn);

   eofloop = 0;
   ndraws  = 0;
   drawcol = 0;

   do until eofloop; 

      drawblock = readr( fhdraw, block_size );
      drawcol = drawcol | drawblock[.,i];

      ndraws = ndraws + rows(drawblock);

      eofloop = eof(fhdraw);

   endo;

   drawcol = drawcol[2:ndraws+1]-drawmean1[i];
   drawacf0 = drawmeanvar1[i];   

   j = 1;
   do until j > hmax;

      drawacf = sumc(drawcol[1+j:ndraws].*drawcol[1:ndraws-j])/ndraws;
      drawmeanvar1[i] = drawmeanvar1[i]+2*(1-j/(hmax+1))*drawacf/ndraws;

      /* drawacf/(ndraws*drawacf0); */

      j = j+1;

   endo;

   i = i+1;

endo;

closeall fhdraws;

drawmeanvar1;



/*******************************************************
** Compute Test Statistics 
*******************************************************/

tstfcn_names = para_names' $| vech( para_names' $+ para_names);

i = 1;
do until i > drawdim;

   tststat = (drawmean0[i]-drawmean1[i])/sqrt( drawmeanvar0[i] + drawmeanvar1[i]);
   $tstfcn_names[i] "  "; tststat;
   " ";
   "---------------------------------";
   " ";
   i = i+1;

endo;
