
/* filename:    var_dsgeirf.g
** description: posterior mode batch
** created:     11/05/01
*/

new;
/** set seed **/
/** rndseed 1234; **/

/********************************************************
* House cleaning and set defaults
********************************************************/
library pgraph, user;
cls;
outwidth 256;

format /mat /on /mb1 /ros 16,8;

/** Global defaults **/
__output = 1;       /** 1 for verbose of CSMIN**/
__graph  = 1;       /** 1 for graph mode **/
_verbose = 2;       /** 0 for silence, 1 for compact, 2 for detailed**/
_fcmptol = 1E-10;

/** only the following 2 lines are model dependent **/
#include nkmp_mod.src;
#include nkmp_para.src;
#include nkmp_spec.g;

para = {   1.2500000
      0.16212911
       1.5427019
      0.81430000
      0.58687321
      0.94751908
      0.58403746
      0.53125497
       3.8760463
      0.52267420
      0.22385734
      0.77780401
      0.54883831 };

para = para';

msel = 1|1;
imp = (0 | 1 | 0);
nirf = 20;

irfsim1 = dsgeirf(para,msel,nirf,imp);

para[4] = para[4]-1E-1;

irfsim2 = dsgeirf(para,msel,nirf,imp);

irfsim1[.,1]~irfsim2[.,1];

end;

/********************************************************************
**   Procedure to compute Impulse Response Function
********************************************************************/
proc (1) = dsgeirf(para,msel,nirf,imp);
local TT,QQ,RR,HH,DD,ZZ,VV,RC, ssirf, yyirf, t;

/**********************************************************
**      System matrices for State-space
**********************************************************/

{TT,QQ,RR,HH,DD,ZZ,VV,RC}=sysmat(para,msel);

ssirf = zeros(nirf,cols(ZZ));
yyirf = zeros(nirf,rows(ZZ));

ssirf[1,.] = (RR*imp)';
yyirf[1,.] = ssirf[1,.]*ZZ';
t = 2;
do until t > nirf;
   ssirf[t,.] = (TT*ssirf[t-1,.]')';
   yyirf[t,.] = ssirf[t,.]*ZZ';
   t = t+1;
endo;

eofirf:

/* Make irf on output cumulative
*/
/*
yyirf[.,1] = cumsumc(yyirf[.,1]);
*/
/* Make irf on inflation cumulative
*/
/*
yyirf[.,2] = cumsumc(yyirf[.,2]);
*/
retp(yyirf);
endp;
