/*************************************************************************
**  Simulate the DSGE model 
**************************************************************************/

/* filename: nkmp_sim.g
** created:  
** Modifications:
**
*/

new;

/** set seed **/
rndseed 1234;

/****************************************************
* Housecleaning and set defaults
****************************************************/

library pgraph, user;
cls;
outwidth 256;

format /mat /on /mb1 /ros 16,8;

_fcmptol = 1E-10;

#include nkmp_mod.src
#include nkmp_para.src
#include nkmp_spec.g
#include nkmp_sim.src

#include pathspec.g
   
/* Load model parameters
*/

para = pmsv(msel);
npara = rows(para);

load path = ^priopath para[npara,3] = "msim_par.out";
para      = para[.,datasel-4];

yt = dsgesim(para,msel,Tsimburn,Tsimtotal);

"Data Simulated Successfully";
"Parameter Choice:    " datasel;
"Model Specification: " msel;
"Parameters (theta):  "; para;
"Mean of YT:          " meanc(yT)';
"StD of YT:           " stdc(yT)';

eofsunsim:

/********************************************************
** Save simulated data
*/

osimdata         = datapath $+ "\\" $+ lmodel $+ "sim" $+ dataselstr $+ "000";
create fhsimdata = ^osimdata with SERIES, cols(yt), 8;
wr               = writer(fhsimdata,yT);
closeall fhsimdata;   

"Data saved";
