/* filename:    nkpm_gewchk1.g
** description: The program computes test functions
** created:     
*/

/********************************************************
* House cleaning and set defaults
********************************************************/
new;
closeall;
library pgraph, user;
cls;
outwidth 256;
format /mat /on /mb1 /ros 16,8;

#include nkmp_mod.src;
#include nkmp_para.src;
#include nkmp_spec.g;

#include pathspec.g;

para  = pmsv(msel);
npara = rows(para);
ntstfcn = npara+npara*(npara+1)/2;

block_size = 1000;
mhrun      = "1";   /* NOTE: we use mhrun = 0 to denote prior */
mhdraws    = "\\pachk";

lpath      = parapath $+ "\\mhrun" $+ mhrun;  
opath      = parapath $+ "\\mhrun" $+ mhrun;

/* Open files with Parameter Draws
*/
ltheta = lpath $+ mhdraws;
open fhltheta = ^ltheta for read;

/* Initialize Output files
*/
otstfcn = opath  $+ "\\patstfcn";
create fhotstfcn = ^otstfcn with TSTFCN, ntstfcn, 8;

/* Initialization
*/ 
eofloop = 0;
loopct  = 0;
nread   = 0;
nvalid  = 0;

do until eofloop; 

   /* Read blocks of size block_size
   */
   thetasim = readr( fhltheta, block_size );
   tstfcnsim = zeros(rows(thetasim),ntstfcn);

   nread   = nread + rows(thetasim);

   j = 1;
   do until j > rows(thetasim);

      tstfcnsim[j,.] = thetasim[j,.]~vech(thetasim[j,.]'*thetasim[j,.])';
      j = j+1;
  endo;


  /* Write Output
  */
  wr = writer(fhotstfcn,tstfcnsim);
  
  loopct = loopct + 1;

  "Loop            " loopct;
  " ";pause(1e-20);
  eofloop = eof(fhltheta);
  
endo;

closeall fhltheta, fhotstfcn;
