/* filename:    paratab-post1.g
** description: generates a LaTeX Table  
*/

new;
closeall;
library user, pgraph;
cls;
outwidth 128;

#include nkmp_mod.src
#include nkmp_para.src
#include nkmp_spec.g
#include nkmp_sim.src

#include pathspec.g

npara = 13;


/******************************************************************
**         Load Parameter Draws from MH Output
*/

/* Specify input files - you have to edit the inputfile_str
** to read the desired estimates
** filename: lmodel + lprior + dataselstr + subTstr + pas
*/
inputfile_str = "\\s5m13t1p1\\para\\mhrun0\\pas"
             $| "\\s5m13t1p1\\para\\mhrun12\\pas"
             $| "\\s6m13t1p1\\para\\mhrun12\\pas";
             


/* Specify row names for table
*/
row_name =  "$\\tau$"          
         $| "$\\kappa$"              
         $| "$\\psi_1$"        
         $| "$\\psi_2$"        
         $| "$\\rho_R$"        
         $| "$\\rho_G$"        
         $| "$\\rho_Z$"        
         $| "$r^{(A)}$"        
         $| "$\\pi^{(A)}$"     
         $| "$\\gamma^{(Q)}$"        
         $| "$\\sigma_R$"      
         $| "$\\sigma_G$"      
         $| "$\\sigma_Z$";
             
inputfile_n = rows(inputfile_str);

npara = rows(row_name);

post_mean = zeros(npara,inputfile_n);
post_ci   = zeros(npara,inputfile_n*2);

/* read the input files
*/
inputfile_ind = 1;

do until inputfile_ind > inputfile_n;

   lparas = workpath $+ inputfile_str[inputfile_ind];
   open fhparas = ^lparas for read;
   
   post_mean[.,inputfile_ind] = readr(fhparas,1)';
   drawrow = seekr(fhparas,npara+3);
   post_ci[.,2*(inputfile_ind-1)+1:2*inputfile_ind] = readr(fhparas,2)';

   inputfile_ind = inputfile_ind+1;
   
   closeall fhparas;
   
endo;



/* Create table
*/
para_ind = 1;
do until para_ind > npara;

   tablerow = row_name[para_ind];

   inputfile_ind = 1;
   
   do until inputfile_ind > inputfile_n;

      tablerow = tablerow $+ " & " $+ ftos(post_mean[para_ind,inputfile_ind],"%*.*lf",5,2)
                 $+ " & [" $+ ftos(post_ci[para_ind,2*(inputfile_ind-1)+1],"%*.*lf",5,2)
                 $+ ", "  $+ ftos(post_ci[para_ind,2*(inputfile_ind)],"%*.*lf",5,2) $+ "]";

                 
      inputfile_ind = inputfile_ind+1;
      
   endo;
   tablerow  = tablerow  $+ "\\\\";
   
   $tablerow;
   
   para_ind = para_ind+1;

endo;
